---
{{ template "common.rbac.ServiceAccount" (list .) }}

---
{{ template "common.rbac.ClusterRole" (list . "prometheus-operator.rbac.ClusterRole") }}

{{- define "prometheus-operator.rbac.ClusterRole" }}
rules:
  - apiGroups:
      - monitoring.coreos.com
    resources:
      - alertmanagers
      - alertmanagers/finalizers
      - alertmanagerconfigs
      - prometheuses
      - prometheuses/finalizers
      - prometheuses/status
      - thanosrulers
      - thanosrulers/finalizers
      - servicemonitors
      - podmonitors
      - probes
      - prometheusrules
    verbs:
      - "*"
  - apiGroups:
      - apps
    resources:
      - statefulsets
    verbs:
      - "*"
  - apiGroups:
      - ""
    resources:
      - configmaps
      - secrets
    verbs:
      - "*"
  - apiGroups:
      - ""
    resources:
      - pods
    verbs:
      - list
      - delete
  - apiGroups:
      - ""
    resources:
      - services
      - services/finalizers
      - endpoints
    verbs:
      - get
      - create
      - update
      - delete
  - apiGroups:
      - ""
    resources:
      - nodes
    verbs:
      - list
      - watch
  - apiGroups:
      - ""
    resources:
      - namespaces
    verbs:
      - get
      - list
      - watch
  - apiGroups:
      - networking.k8s.io
    resources:
      - ingresses
    verbs:
      - get
      - list
      - watch
{{- end }}

---
{{ template "common.rbac.ClusterRoleBinding" (list . "prometheus-operator.rbac.ClusterRoleBinding") }}

{{- define "prometheus-operator.rbac.ClusterRoleBinding" }}
roleRef:
  apiGroup: rbac.authorization.k8s.io
  kind: ClusterRole
  name: {{ template "common.fullname" . }}
subjects:
  - kind: ServiceAccount
    name: {{ template "common.fullname" . }}
    namespace: {{ .Release.Namespace }}
{{- end }}

---
# ClusterRole used by Prometheus instances
{{ template "common.rbac.ClusterRole" (list . "prometheus-operator.rbac.ClusterRole.prometheus") }}

{{- define "prometheus-operator.rbac.ClusterRole.prometheus" }}
metadata:
  name: prometheus
rules:
  - apiGroups:
      - ""
    resources:
      - nodes
      - nodes/proxy
      - nodes/metrics
      - services
      - endpoints
      - pods
    verbs:
      - get
      - list
      - watch
  - apiGroups:
      - ""
    resources:
      - configmaps
    verbs:
      - get
  - apiGroups:
      - networking.k8s.io
    resources:
      - ingresses
    verbs:
      - get
      - list
      - watch
  - nonResourceURLs:
      - /metrics
    verbs:
      - get
{{- end }}
